commit c8b549857d968d634a74709112e5acc9f9caf35c
Author: Richard Biener <rguenther@suse.de>
Date:   Wed Jul 24 13:16:35 2024 +0200

    tree-optimization/116057 - wrong code with CCP and vector CTORs
    
    The following fixes an issue with CCPs likely_value when faced with
    a vector CTOR containing undef SSA names and constants.  This should
    be classified as CONSTANT and not UNDEFINED.
    
            PR tree-optimization/116057
            * tree-ssa-ccp.cc (likely_value): Also walk CTORs in stmt
            operands to look for constants.
    
            * gcc.dg/torture/pr116057.c: New testcase.
    
    (cherry picked from commit 1ea551514b9c285d801ac5ab8d78b22483ff65af)

diff --git a/gcc/testsuite/gcc.dg/torture/pr116057.c b/gcc/testsuite/gcc.dg/torture/pr116057.c
new file mode 100644
index 00000000000..a7021c8e746
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/torture/pr116057.c
@@ -0,0 +1,20 @@
+/* { dg-do run } */
+/* { dg-additional-options "-Wno-psabi" } */
+
+#define vect8 __attribute__((vector_size(8)))
+
+vect8 int __attribute__((noipa))
+f(int a)
+{
+  int b;
+  vect8 int t={1,1};
+  if(a) return t;
+  return (vect8 int){0, b};
+}
+
+int main ()
+{
+  if (f(0)[0] != 0)
+    __builtin_abort ();
+  return 0;
+}
diff --git a/gcc/tree-ssa-ccp.cc b/gcc/tree-ssa-ccp.cc
index 3c63f2dd8a3..629cb3c2d82 100644
--- a/gcc/tree-ssa-ccp.cc
+++ b/gcc/tree-ssa-ccp.cc
@@ -750,6 +750,17 @@ likely_value (gimple *stmt)
 	continue;
       if (is_gimple_min_invariant (op))
 	has_constant_operand = true;
+      else if (TREE_CODE (op) == CONSTRUCTOR)
+	{
+	  unsigned j;
+	  tree val;
+	  FOR_EACH_CONSTRUCTOR_VALUE (CONSTRUCTOR_ELTS (op), j, val)
+	    if (CONSTANT_CLASS_P (val))
+	      {
+		has_constant_operand = true;
+		break;
+	      }
+	}
     }
 
   if (has_constant_operand)

